#ifdef GL_ES
precision mediump float;
#endif

uniform sampler2D texture;

varying vec4 vertexColor;
varying vec2 texCoord;

vec4 sepia( vec4 color )
{
    return vec4(
          clamp(color.r * 0.393 + color.g * 0.769 + color.b * 0.189, 0.0, 1.0),
          clamp(color.r * 0.349 + color.g * 0.686 + color.b * 0.168, 0.0, 1.0),
          clamp(color.r * 0.272 + color.g * 0.534 + color.b * 0.131, 0.0, 1.0),
          color.a
    );
}

void main()
{
    vec4 c = texture2D(texture, texCoord).rgba;
	gl_FragColor = mix(c, sepia(c), vec4(0.5, 0.5, 0.5, 0.5)) * vertexColor;
}
